=== vendor/github.com/benhoyt/inih/meson_options.txt ===
option('distro_install',
  type : 'boolean',
  value : true,
  description : 'install shared libs, headers and pkg-config entries'
)
option('with_INIReader',
  type : 'boolean',
  value : true,
  description : 'compile and (if selected) install INIReader'
)
option('multi-line_entries',
  type : 'boolean',
  value : true,
  description : 'support for multi-line entries in the style of Python\'s ConfigParser'
)
option('utf-8_bom',
  type : 'boolean',
  value : true,
  description : 'allow a UTF-8 BOM sequence (0xEF 0xBB 0xBF) at the start of INI files'
)
option('inline_comments',
  type : 'boolean',
  value : true,
  description : 'allow inline comments with the comment prefix character'
)
option('inline_comment_prefix',
  type : 'string',
  value : ';',
  description : 'character(s) to start an inline comment (if enabled)'
)
option('start-of-line_comment_prefix',
  type : 'string',
  value : ';#',
  description : 'character(s) to start a comment at the beginning of a line'
)
option('allow_no_value',
  type : 'boolean',
  value : false,
  description : 'allow name with no value'
)
option('stop_on_first_error',
  type : 'boolean',
  value : false,
  description : 'stop parsing after an error'
)
option('report_line_numbers',
  type : 'boolean',
  value : false,
  description : 'report line number on ini_handler callback'
)
option('call_handler_on_new_section',
  type : 'boolean',
  value : false,
  description : 'call the handler each time a new section is encountered'
)
option('use_heap',
  type : 'boolean',
  value : false,
  description : 'allocate memory on the heap using malloc instead using a fixed-sized line buffer on the stack'
)
option('max_line_length',
  type : 'integer',
  value : 200,
  description : 'maximum line length in bytes'
)
option('initial_malloc_size',
  type : 'integer',
  value : 200,
  description : 'initial malloc size in bytes (when using the heap)'
)
option('allow_realloc',
  type : 'boolean',
  value : false,
  description : 'allow initial malloc size to grow to max line length (when using the heap)'
)
